#!/usr/bin/python
#
# This program is distributed under the terms of the GNU General Public License
# Copyright (c) 2013 Barry Brosnihan barry@brosnihan.co.uk
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
# Version 1.3.8

import subprocess
import time
import sys
import os
import shlex
import Queue
import threading
import pygame.mixer
import time
import copy
import Adafruit_Trellis
from datetime import datetime

#Variables
action = []
spacing = 0
sleep = 0
#sample_dir="/opt/playpi/samples"
#sample_dir="/music/HardWired/Eat\ You\ and\ Me/"
sample_dir="/music/HardWired/Test\ Track"
#sample_dir="../kit/"
track_dir="./tracks/"
sample_list = []
track_list = []
current_sample_list = []
current_track_list = []
current_track_selection = ""
exitfunction = 1
exitprogram = 1
printoutmenu = 1
printsamplestart = 0
printsampleend = 16
printtrackstart = 0
printtrackend = 16
currentsequence = 0
totalsequence = 256
stepstart = 0
stepend = 16
patstart = 0
patend = 16
currentstep = 0
laststep = 0
lightcurrentstep = 0
sequencer_status = 0
sequencer_status_display=["Stopped","Playing"]
pygamechannels=32
tempo=120.0
sequencer_list=[[[] for sequencer_list in range(256)] for b in range(totalsequence)]
pattern = []
patternindex = []
queueLock = threading.Lock()
buttonQueue = Queue.Queue(10)
sounddict={}
special_sequence_options = ["START","END","MUTE"]
sequencer_mode = ["Sequencer","Pattern"]
sequencer_mode_current = 0
pattern_sequence = 0
# We are setting up two Trellis's! Most of this code has been taking from the Test_Trellis.py
matrix0 = Adafruit_Trellis.Adafruit_Trellis()
matrix1 = Adafruit_Trellis.Adafruit_Trellis()
trellis = Adafruit_Trellis.Adafruit_TrellisSet(matrix0, matrix1)
# set to however many you're working with here, up to 8 per I2C bus
NUMTRELLIS = 2
numKeys = NUMTRELLIS * 16
# Set this to the number of the I2C bus that the Trellises are attached to:
I2C_BUS = 1
trellis.begin((0x70,  I2C_BUS), (0x71, I2C_BUS))



#Pygame Init
#pygame.mixer.init(44100, -16, 2, 512)
pygame.mixer.init(44100, -16, 2, 1024)
pygame.mixer.set_num_channels(pygamechannels)
pygame.init()

#Menus
firstmenu = ["16. Start/Stop Sequencer", "17. Sequencer Builder", "18. Pattern Builder", "19. Rebuild Sound Dictionary","20. Change Temp", "21. Load File", "22. Save As", "23. Quick Save", "24. Clear All","25. Reload Sample List", "28. Playback Type", "31. Exit Program"]
sampleaddremovemenu = ["A. Start/Stop Sequencer", "1. ", "2. Pattern Builder", "E. Exit Program"]
patternaddremovemenu = ["1. Overwrite Current Sequence", "2. Insert Current Sequence: Before", "3. Insert Current Sequence: After","4. Delete Selected Sequence From Pattern","E. Exit"]
menutitle = ["Sequence Builder.","Select Sample.","Add/Remove Sample from Sequence","Pattern Builder.","Pattern Editor","Pattern Add/Remove", "Loading...", "Saving...","No Track Selected","Loading Samples..."]

#Led Menus
mainmenu=[16,17,18,19,20,21,22,23,24,28,31]
leddisplaydict={'mainmenu': mainmenu}



# Build the sample list.
rootdir = sample_dir
# Add the samples to the sample_list
#hardwireddir="/music/HardWired"
#hardwireddir="/music/HardWired/Eat You and Me"
#hardwireddir="/music/HardWired/Remote Extraction"
hardwireddir="/music/HardWired/In Order"
#hardwireddir="/music/HardWired/Test Track"

def printmenu(list):
 global printoutmenu
 if printoutmenu == 1:
        os.system("clear")
        print "Print Menu - Start"
        for item in list:
                print item
                printoutmenu = 0


def create_sample_list():
 global menutitle
 global sample_list
 global printoutmenu
 printoutmenu = 1
 sample_list=[]
 #Add special options to the start of the list.
 for special_item in special_sequence_options:
	sample_list.append(special_item)
 print menutitle[9]
 for root, subFolders, files in os.walk(hardwireddir):
    for file in files:
        sample_list.append(os.path.join(root,file))
 # Add the samples to the sample_list
 for root, subFolders, files in os.walk(rootdir):
    for file in files:
        sample_list.append(os.path.join(root,file))
 printmenu(firstmenu)

create_sample_list()

#Function Start

# Test LEDS
def trellis_startup_test():
# light up all the LEDs in order
 for i in range(numKeys):
         trellis.setLED(i)
         trellis.writeDisplay()
         time.sleep(0.05)
 # then turn them off
 for i in range(numKeys):
         trellis.clrLED(i)
         trellis.writeDisplay()
         time.sleep(0.05)

#trellis_startup_test()

# Build the track list.
def buildtracklist():
 global track_list
 track_list = []
 for root, subFolders, files in os.walk(track_dir):
 	for file in files:
 		track_list.append(os.path.join(root,file))
buildtracklist()


# This function below is a little rubbish. 
def savefile():
 global sequencer_list
 global pattern
 global tempo
 global current_track_selection 
 global menutitle
 global printoutmenu
 print menutitle[7]
 # Set the output file.
 outfile = open(current_track_selection,"w")
 # Write the current tempo to file.
 outfile.write(str(tempo))
 outfile.write("\n")
 # Write the current pattern to file.
 start_count = 0
 for i in pattern:
 	outfile.write(str(i))
 	end_of_list = start_count 
 	end_of_list += 1
        if end_of_list != len(pattern):
        	outfile.write(",")
	start_count += 1

 outfile.write("\n")
 for w in range(0, len(sequencer_list)):
  for i in range(0, len(sequencer_list[w])):
        for j in range(0, len(sequencer_list[w][i])):
                        outfile.write(str(sequencer_list[w][i][j]))
                        x = j
                        x += 1
                        if x != len((sequencer_list[w][i])):
                                outfile.write(",")
        outfile.write("\n")
 
 outfile.close()
 printoutmenu = 1
 printmenu(firstmenu)
 return

def showfiles():
 global track_list
 global exitfunction
 global printoutmenu
 global printtrackstart
 global printtrackend
 global menutitle
 global current_track_selection
 printoutmenu = 1
 printtracks()
 while exitfunction != 0:
        if not buttonQueue.empty():
                queueLock.acquire()
                button = buttonQueue.get()
                buttonQueue.task_done()
                queueLock.release()
                if button == 31:
                        exitfunction = 0
                        printoutmenu = 1
                elif button == 16:
                        printtrackstart -= 16
                        printtrackend -= 16
                        printoutmenu = 1
			printtracks()
                elif button == 17:
                        printtrackstart += 16
                        printtrackend += 16
                        printoutmenu = 1
			printtracks()
                elif button <= 15 and button >= 0:
			if button >= len(track_list):
				print "Sorry, no track.", len(track_list)
			else:
                        	current_track_selection = current_track_list[button]
                        	current_track_number = button
                        	printoutmenu = 1
                        	printtracks()
                        	print "Current Track Selected=", current_track_selection
                elif button == 28:
			if current_track_selection == "":
				print menutitle[9]
			else:
				print menutitle[6]
				loadfile()
				exitfunction = 0
				printoutmenu = 1
                elif button == 20:
			select_track_number()
                elif button == 29:
			if current_track_selection == "":
				print menutitle[9]
			else:
				print menutitle[8]
				savefile()
				exitfunction = 0
				printoutmenu = 1

                else:
                        printoutmenu = 1

        time.sleep(.1)
 exitfunction = 1

def select_track_number():
 global exitfunction
 global printoutmenu
 global current_track_selection
 global track_dir
 trackno = 0
 print "Select Track Number - Start"
 while exitfunction != 0:
        if not buttonQueue.empty():
                queueLock.acquire()
                button = buttonQueue.get()
                buttonQueue.task_done()
                queueLock.release()
                if button == 31:
                        exitfunction = 0
                        printoutmenu = 1
 			printtracks()
                elif button == 16:
                        trackno -= 1
			current_track_selection = track_dir + "track" + str(trackno) + ".playpi"
			print "Current Track Selected=", current_track_selection
                elif button == 17:
                        trackno += 1
			current_track_selection = track_dir + "track" + str(trackno) + ".playpi"
			print "Current Track Selected=", current_track_selection
                elif button == 18:
                        trackno -= 5
			current_track_selection = track_dir + "track" + str(trackno) + ".playpi"
			print "Current Track Selected=", current_track_selection
                elif button == 19:
                        trackno += 5
			current_track_selection = track_dir + "track" + str(trackno) + ".playpi"
			print "Current Track Selected=", current_track_selection
                elif button == 28:
                        if current_track_selection == "":
                                print "No Track Selected"
                        else:
                                savefile()
                                exitfunction = 0
                                printoutmenu = 1
 				printtracks()
        time.sleep(.1)
 exitfunction = 1
 return


 return

# This is a litte rubbish to.
def loadfile():
 global sequencer_list
 global tempo
 global pattern
 global totalsequence
 global current_track_selection
 infile = open(current_track_selection,"r")
 inlist = infile.read()
 infile.close()
 counter = 0
 seqcounter = 0
 
 # Clear the pattern list.
 pattern = []
 # Clear the Sequencer List
 sequencer_list=[[[] for sequencer_list in range(256)] for b in range(totalsequence)]
 
 filelinecounter = 0
 for i in inlist.split('\n'):
	if filelinecounter == 0:
 		tempo = float(i)
	if filelinecounter == 1:
 		for x in i.split(','):
 			pattern.append(int(x))
	if filelinecounter >= 2:
		if counter == 255:
               		seqcounter += 1
 			counter = -1
		if i.strip():
 			for j in i.split(','):
 				sequencer_list[seqcounter][counter].append(str(j))
        	counter += 1
 	filelinecounter += 1
 # Load the samples into the sounddict
 createsounddict(sequencer_list)
 return

def createsounddict(sequencer_list):
 os.system("clear")
 print "Loading samples into memory....."
 global printoutmenu
 global sounddict
 global exitfunction
 global special_sequence_options
 sounddict = {}
 dictlist = []
 # Go though every sequencer and place uniq samples in dictlist
 for seqcount in range(0, len(sequencer_list)):
 	for seq in range(0, len(sequencer_list[seqcount])):
 		for sample in range(0, len(sequencer_list[seqcount][seq])):
 			if sequencer_list[seqcount][seq][sample] not in dictlist:
 				dictlist.append(sequencer_list[seqcount][seq][sample])

 # Check and remove options.
 for special_item in special_sequence_options:
 	if special_item in dictlist:
 		dictlist.remove(special_item)

 # Load the samples into a dictionary and ref by sample location.
 for sample in range(0,len(dictlist)):
	sounddict[str(dictlist[sample])] = pygame.mixer.Sound(str(dictlist[sample]))
 printoutmenu = 1
 printmenu(firstmenu)
 return

def printsequence(sequence,stepstart,stepend):
 print "Print Sequence Start:"
 global printoutmenu
 global pattern
 counter = stepstart
 counter += 1
 
 if printoutmenu == 1:
	os.system("clear")
	# We need to Add 1 to the sequence count so people dont get confused.
	display_sequence = sequence 
	display_sequence += 1
	for step in range(stepstart,stepend):
		print counter,")",sequencer_list[sequence][step]
		counter += 1  
	print "Steps:",stepstart,"/",stepend, "Sequencer:", display_sequence,"/",len(sequencer_list)
	print "Pattern: ",pattern
	printoutmenu = 0
 return

def printpattern():
 global pattern
 global printoutmenu
 global currentsequence
 global sequencer_list
 global patstart
 global patend

# Make sure users can only select valid index's
 if len(pattern) < patend:
	patrealend = len(pattern)
 else:
 	patrealend = patend

 if patstart < 0:
 	patstart = 0
	patend = 16
 elif patstart > len(pattern):
 	patstart = 0
 	patend = 16

 counter = 1
 pattern_counter = patstart

 if printoutmenu == 1:
 	if len(pattern) < 16:
 		os.system("clear")
		for sequence in pattern:
			print counter,") (",pattern_counter,") Sequence:",sequence
			counter +=1
			pattern_counter +=1
		print "Sequencer:", currentsequence,"/",len(sequencer_list)
		print "Pattern: ",pattern
		printoutmenu = 0
	else:
		os.system("clear")
		for sequence in range(patstart,patrealend):
			print counter,") (",pattern_counter,") Sequence:",pattern[sequence]
			counter +=1
			pattern_counter +=1
		print "Sequencer:", currentsequence,"/",len(sequencer_list)
		print "Pattern: ",pattern
		printoutmenu = 0
 print "Pat start/end",patstart,patrealend
 return

def printtracks():
 buildtracklist()
 global track_list 
 global printoutmenu
 global printtrackstart
 global printtrackend
 global current_track_list
 counter = 1

# Make sure users can only select valid index's
 if len(track_list) < printtrackend:
        trackrealend = len(pattern)
 else:
        trackrealend = printtrackend

 if printtrackstart < 0:
        printrackstart = 0
        printtrackend = 16
 elif printtrackstart > len(track_list):
        printtrackstart = 0
        printtrackend = 16

 if printoutmenu == 1:
        if len(track_list) < 16:
                os.system("clear")
                for playpi_track in track_list:
                        print counter,") Track:",playpi_track
                        counter +=1
        		current_track_list.append(playpi_track)
                printoutmenu = 0
        else:
                os.system("clear")
                for playpi_track in range(printtrackstart,tracktrealend):
                        print counter,") Track:",playpi_track
                        counter +=1
        		current_track_list.append(playpi_track)
                printoutmenu = 0
	
 return

# Control the Leds
def leddisplay(led,setstatus):
	if setstatus == 0:
		trellis.clrLED(led)
		trellis.writeDisplay()
	if setstatus == 1:
		trellis.setLED(led)
		trellis.writeDisplay()
	# Speed up the trellis code
	#else: 
	#	leds = leddisplaydict[ledgroup]
	#	if setstatus == 0:
	#		for led in leds:
	#			trellis.clrLED(led)
	#			trellis.writeDisplay()
	#	if setstatus == 1:
	#		for led in leds:
	##			trellis.setLED(led)
	#			trellis.writeDisplay()
				
		
	

def printsamples(start,end):
 global current_sample_list 
 printoutmenu = 1
 counter = 1
 current_sample_list = []
 os.system("clear")
 for sample in range(start,end):
	if sample >= len(sample_list):
		break
 	print counter ,")", sample_list[sample]
 	counter += 1
 	current_sample_list.append(sample_list[sample])
 printoutmenu = 0
 print menutitle[1]
 return

def sampleremove(button):
 global printoutmenu
 printoutmenu = 1
 print "Sample Add Remove - Start"
 print sample_list
 return

def playsample(sample):
 global current_sample_list 
 if current_sample_list[sample] not in special_sequence_options:
 	samplefile = current_sample_list[sample]
 	sampleplayback = pygame.mixer.music
 	sampleplayback.load(samplefile)
 	sampleplayback.play()
 	printoutmenu = 1

def addtosequence(sample,current_sample_number):
 global currentsequence 
 global stepstart
 global stepend
 global sequencer_list
 global exitfunction
 global printoutmenu
 global printsamplestart
 global printsampleend
 global menutitle
 printoutmenu = 1
 printsequence(currentsequence,stepstart,stepend)
 print currentsequence
 print menutitle[2]
 while exitfunction != 0:
        if not buttonQueue.empty():
                queueLock.acquire()
                button = buttonQueue.get()
                buttonQueue.task_done()
                queueLock.release()
                print "Add to sequence: You Pressed: ", button
                if button == 31:
                        exitfunction = 0
                        printoutmenu = 1
			printsamples(printsamplestart,printsampleend)
                elif button == 16:
                        stepstart -= 16
                        stepend -= 16
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[2]
                elif button == 17:
                        stepstart += 16
                        stepend += 16
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[2]
                elif button == 18:
                        currentsequence -= 1
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
			print menutitle[2]
                elif button == 19:
                        currentsequence += 1
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
			print menutitle[2]
                elif button <= 15 and button >= 0:
                     	playsample(current_sample_number)
			# I shall change this when I find a better way to nap the numbers
			current_number = 0
			selected_step = 0
			for i in range(stepstart,stepend):
				if current_number == button:
					selected_step = i
				current_number += 1
			# Check to see if the sample is already there. If not the add it, if its there remove it.
			if sample in  sequencer_list[currentsequence][selected_step]:
				sequencer_list[currentsequence][selected_step].remove(sample)
			else:
				sequencer_list[currentsequence][selected_step].append(sample)
			printoutmenu = 1
 			printsequence(currentsequence,stepstart,stepend)
			print menutitle[2]
                else:
                        printoutmenu = 1

 	time.sleep(.1)
 exitfunction = 1
 return

 


def sampleadd(sequence):
 global exitfunction
 global printoutmenu
 global printsamplestart
 global printsampleend
 global currentsequence
 global menutitle
 printsamples(printsamplestart,printsampleend)
 while exitfunction != 0:
	if not buttonQueue.empty():
                queueLock.acquire()
                button = buttonQueue.get()
                buttonQueue.task_done()
                queueLock.release()
                if button == 31:
                        exitfunction = 0
                        printoutmenu = 1
 			printsequence(currentsequence,stepstart,stepend)
                elif button == 16:
                        printsamplestart -= 16
                        printsampleend -= 16
                        printoutmenu = 1
                        printsamples(printsamplestart,printsampleend)
                        print "current sample", printsamplestart, printsampleend 
                elif button == 17:
                        printsamplestart += 16
                        printsampleend += 16
                        printoutmenu = 1
                        printsamples(printsamplestart,printsampleend)
                        print "current sample", printsamplestart, printsampleend 
		elif button <= 15 and button >= 0:
			if button >= len(current_sample_list):
                        	print "Sorry, no sample."
                        	printoutmenu = 1
			else:
				playsample(button)
				current_sample_selection = current_sample_list[button]
				current_sample_number = button
 				printsamples(printsamplestart,printsampleend)
				print "Current Sample Select=", current_sample_selection
		elif button == 28:
			addtosequence(current_sample_selection,current_sample_number)
			
                else:
                        printoutmenu = 1

	time.sleep(.1)
 exitfunction = 1
 return

def changetempo():
 global exitfunction
 global printoutmenu
 global tempo
 print "Change Temp - Start"
 while exitfunction != 0:
        if not buttonQueue.empty():
                queueLock.acquire()
                button = buttonQueue.get()
                buttonQueue.task_done()
                queueLock.release()
                if button == 31:
                        exitfunction = 0
                        printoutmenu = 1
                elif button == 16:
                        tempo -= 1
                        #print "Tempo", tempo 
                        #print "-1" 
                elif button == 17:
                        tempo += 1
                        #print "+1" 
                        #print "Tempo", tempo 
                elif button == 18:
                        tempo -= 5
                        #print "Tempo", tempo 
                        #print "-5" 
                elif button == 19:
                        tempo += 5
                        #print "Tempo", tempo 
                        #print "+5"
        time.sleep(.1)
 exitfunction = 1
 return

def patternindexbuilder():
 # I am using this to build a index that I can use to edit patterns that go beyond 16 sequenceres
 global pattern
 global patstart
 global patend
 global patternindex

 patternindex = []

 if len(pattern) < patend:
        patrealend = len(pattern)
 else:
        patrealend = patend

 if patstart < 0:
        patstart = 0
        patend = 16
 elif patstart > len(pattern):
        patstart = 0
        patend = 16

 for button_map in range(patstart,patrealend):
	patternindex.append(button_map)


def patternaddremove(selected_pattern_no):
 patternindexbuilder()
 global pattern
 global exitfunction
 global printoutmenu
 global currentsequence
 global stepstart
 global stepend
 global patstart
 global patend
 global menutitle
 global sequencer_list
 global patternaddremovemenu
 global patternindex
 printoutmenu = 1
 printmenu(patternaddremovemenu)
 printoutmenu = 1
 print "Selected Sequence: ", selected_pattern_no
 print "Current Sequence: ", currentsequence
 
 print patternindex

 while exitfunction != 0:
        if not buttonQueue.empty():
                queueLock.acquire()
                button = buttonQueue.get()
                buttonQueue.task_done()
                queueLock.release()
                print menutitle[5]
                if button == 31:
                        exitfunction = 0
                        printoutmenu = 1
 			printpattern()
                elif button == 16:
                        currentsequence -= 1
                        printoutmenu = 1
 			printmenu(patternaddremovemenu)
 			print "Selected Sequence: ", selected_pattern_no
			print "Current Sequence: ", currentsequence
                elif button == 17:
                        currentsequence += 1
                        printoutmenu = 1
 			printmenu(patternaddremovemenu)
 			print "Selected Sequence: ", selected_pattern_no
			print "Current Sequence: ", currentsequence
                elif button == 0:
                        exitfunction = 0
                        pattern[patternindex[selected_pattern_no]] = currentsequence
                        printoutmenu = 1
 			printpattern()
                elif button == 1:
                        exitfunction = 0
			selected_pattern_no -= 1
			if selected_pattern_no < 0:
				selected_pattern_no = 0
                        pattern.insert(patternindex[selected_pattern_no],currentsequence)
                        printoutmenu = 1
 			printpattern()
                elif button == 2:
                        exitfunction = 0
			selected_pattern_no += 1
			if selected_pattern_no > 15:
				selected_pattern_no = 15
                        pattern.insert(patternindex[selected_pattern_no],currentsequence)
                        printoutmenu = 1
 			printpattern()
                elif button == 3:
                        exitfunction = 0
                        pattern.pop(patternindex[selected_pattern_no])
                        printoutmenu = 1
 			printpattern()
                else:
                        printoutmenu = 1
        time.sleep(.1)
 exitfunction = 1
 printoutmenu = 1
 return

def patterneditor():
 global exitfunction
 global printoutmenu
 global currentsequence
 global stepstart
 global stepend
 global patstart
 global patend
 global menutitle
 global sequencer_list
 global pattern
 global patternindex
 print menutitle[4]
 printoutmenu = 1
 printpattern()
 while exitfunction != 0:
        if not buttonQueue.empty():
                queueLock.acquire()
                button = buttonQueue.get()
                buttonQueue.task_done()
                queueLock.release()
                print menutitle[4]
                if button == 31:
                        exitfunction = 0
                        printoutmenu = 1
 			printsequence(currentsequence,stepstart,stepend)
                elif button == 16:
                        patstart -= 16
                        patend -= 16
                        printoutmenu = 1
                        printpattern()
                        print menutitle[4]
                elif button == 17:
                        patstart += 16
                        patend += 16
                        printpattern()
                        printoutmenu = 1
                        printpattern()
                        print menutitle[4]
                elif button == 18:
                        currentsequence -= 1
                        printoutmenu = 1
                        printpattern()
                        print menutitle[4]
                elif button == 19:
                        currentsequence += 1
                        printoutmenu = 1
                        printpattern()
                        print menutitle[4]
                elif button == 20:
                        pattern.append(currentsequence)
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print menutitle[4]
                elif button <= 15 and button >= 0:
 			patternindexbuilder()
			if button >= len(patternindex):
				print "Sorry No Pattern!"
			else:
                        	patternaddremove(button)
                else:
                        printoutmenu = 1
        time.sleep(.1)
 exitfunction = 1
 printoutmenu = 1
 return


def patternbuilder():
 global exitfunction
 global printoutmenu
 global currentsequence
 global stepstart
 global stepend
 global menutitle
 global sequencer_list
 global pattern
 print menutitle[3]
 printoutmenu = 1
 printsequence(currentsequence,stepstart,stepend)
 while exitfunction != 0:
        if not buttonQueue.empty():
                queueLock.acquire()
                button = buttonQueue.get()
                buttonQueue.task_done()
                queueLock.release()
                if button == 31:
                        exitfunction = 0
                        printoutmenu = 1
                elif button == 28:
                        patterneditor()
                elif button == 16:
                        stepstart -= 16
                        stepend -= 16
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[3]
                elif button == 17:
                        stepstart += 16
                        stepend += 16
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[3]
                elif button == 18:
                        currentsequence -= 1
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[3]
                elif button == 19:
                        currentsequence += 1
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[3]
		elif button == 20:
			pattern.append(currentsequence)
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[3]
		elif button == 21:
			pattern.pop()
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[3]
                #elif button <= 15 and button >= 0:
                #elif button <= 15 and button >= 0:
                #        sampleremove(button)
                else:
                        printoutmenu = 1
        time.sleep(.1)
 exitfunction = 1
 return



	

def sequencerbuilder():
 global exitfunction
 global printoutmenu
 global currentsequence
 global stepstart
 global stepend
 global menutitle
 global sequencer_list
 undo = 0
 copylist = []
 undolist = []
 print "Sequencer Builder - Start"
 # Print out the sequence and step information for the user here before main loop starts, as main loop requires input to trigger.
 # printoutmenu needs to be set to 1 to let the out for the first time!
 printoutmenu = 1
 printsequence(currentsequence,stepstart,stepend)
 print menutitle[0]
 while exitfunction != 0:
	if not buttonQueue.empty():
                queueLock.acquire()
                button = buttonQueue.get()
                buttonQueue.task_done()
                queueLock.release()
                print "Sequencer Builder: You Pressed: ", button
                if button == 31:
                        exitfunction = 0
 			printoutmenu = 1
		elif button == 28:
			sampleadd(currentsequence)
                elif button == 16:
                        stepstart -= 16
                        stepend	-= 16
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[0]
                elif button == 17:
                        stepstart += 16
                        stepend += 16
                        printoutmenu = 1
                        printsequence(currentsequence,stepstart,stepend)
                        print "current sequence", currentsequence
                        print menutitle[0]
		elif button == 18:
			currentsequence -= 1 
			printoutmenu = 1
 			printsequence(currentsequence,stepstart,stepend)
			print "current sequence", currentsequence 
 			print menutitle[0]
		elif button == 19:
			currentsequence += 1  
			printoutmenu = 1
 			printsequence(currentsequence,stepstart,stepend)
			print "current sequence", currentsequence 
 			print menutitle[0]
		elif button == 20:
			print "Copy Sequence"
			copylist = copy.deepcopy(sequencer_list[currentsequence])
		elif button == 21:
			if undo == 0:
				undolist = copy.deepcopy(sequencer_list[currentsequence])
				sequencer_list[currentsequence] = copy.deepcopy(copylist)
				printoutmenu = 1
 				printsequence(currentsequence,stepstart,stepend)
				undo = 1
				print "Paste Sequence"
			elif undo == 1:
				sequencer_list[currentsequence] = copy.deepcopy(undolist)
				printoutmenu = 1
 				printsequence(currentsequence,stepstart,stepend)
				undo = 0
				print "Undo Paste Sequence"
		elif button <= 15 and button >= 0:
			sampleremove(button)
		else:
			printoutmenu = 1

	time.sleep(.1)
 exitfunction = 1
 return

 

def mainmenu():
 global exitprogram
 global sequencer_status
 global sequencer_mode
 global sequencer_mode_current
 global pattern
 global sequencer_list
 while exitprogram != 0:
 	printmenu(firstmenu)
	# This is here for when I come back and enable this.
	#leddisplay(0,1,"mainmenu")
	if not buttonQueue.empty():
		queueLock.acquire()
        	button = buttonQueue.get()
		buttonQueue.task_done()
        	queueLock.release()
		#print "Menu: You Pressed: ", button
		if button == 31:
			print "Time to exit"
			exitprogram = 0
		elif button == 16:
			if sequencer_status == 0:
				sequencer_status = 1
			elif sequencer_status == 1:
				sequencer_status = 0
		elif button == 28:
			if sequencer_mode_current == 0:
				sequencer_mode_current = 1
			else:
				sequencer_mode_current = 0
		elif button == 17:
			sequencerbuilder()
		elif button == 18:
			patternbuilder()
		elif button == 19:
			createsounddict(sequencer_list)
		elif button == 20:
			changetempo()
		elif button == 21:
			showfiles()
		elif button == 22:
			showfiles()
		elif button == 23:
			savefile()
		elif button == 24:
 			pattern = []
			sequencer_list=[[[] for sequencer_list in range(256)] for b in range(totalsequence)]
		elif button == 25:
			create_sample_list()
	time.sleep(.1)
 return

mainmenu = threading.Thread(target=mainmenu, args=[])
mainmenu.start()

def sequencer():
 global sequencer_list
 global sequencer_status
 global exitprogram
 global sounddict
 global tempo
 global currentsequence
 global currentstep
 global lightcurrentstep
 global laststep
 global special_sequence_options 
 global sequencer_mode_current 
 global pattern_sequence 
 ENDHIT = "0"
 enddelta = 0
 while exitprogram != 0:
	while sequencer_status == 1 :
 		# Stop the sequencer if we have been told to exit
 		if exitprogram == 0:
			sequencer_status = 0
		if sequencer_mode_current == 0:
		 for index,step in enumerate(sequencer_list[currentsequence]):
        		if "END" in step:
				laststep = index
		 for index, step in enumerate(sequencer_list[currentsequence]):
		 	# Start the time delta.
		 	starttime = time.time()
			currentstep = index
			# Why is this here.....?
			#if currentstep == 0:
			#	currentstep += 1
        		samplecount = len(step)
			if ENDHIT == "1":
				ENDHIT = "0"
				break
			# Turn LEDS on here!
			# Below is for the play button!
			if currentstep%2==0:
				leddisplay(16,1)
			else:	
				leddisplay(16,0)
			# The Step LEDs	
			# Calculate what LED to turn on.
			if currentstep >= 16:
				setledstep = currentstep%16
				leddisplay(setledstep,1)
			else:
				setledstep = currentstep
				leddisplay(setledstep,1)
                	for sample in range(0, samplecount):
				if step[sample] == "END":
                                	ENDHIT="1"	
				# Check the sample is actully loaded, and if not load it.
				if step[sample] not in sounddict and step[sample] not in special_sequence_options:
					createsounddict(sequencer_list)
		 			starttime = time.time()
				if "MUTE" not in step and step[sample] not in special_sequence_options:
					cx = pygame.mixer.find_channel()
					cx.play(sounddict[step[sample]])
			# End time for the time delta.
			endtime = time.time()
			timedelta = endtime - starttime
			timedelta += enddelta
			sleeptime = tempocalc(tempo,timedelta)
 		        time.sleep(sleeptime)
			# Turn Lights off here!
			# The Step LEDs	
			starttime = time.time()
			leddisplay(setledstep,0)
			endtime = time.time()
			enddelta = endtime - starttime
			if sequencer_status == 0:
				break

		elif sequencer_mode_current == 1:
		 for pattern_sequence in pattern:
			if sequencer_mode_current == 0:
				break
			if exitprogram == 0:
				break
		 	for index,step in enumerate(sequencer_list[pattern_sequence]):
        			if "END" in step:
					laststep = index
			for index, step in enumerate(sequencer_list[pattern_sequence]):
		 		# Start the time delta.
		 		starttime = time.time()
				currentstep = index
                        	samplecount = len(step)
                        	if ENDHIT == "1":
                               		ENDHIT = "0"
                                	break
				# Turn LEDS on here!
                        	# Below is for the play button!
                        	if currentstep%2==0:
                               		leddisplay(16,1)
                        	else:
                               		leddisplay(16,0)
				if currentstep >= 16:
                                	setledstep = currentstep%16
                                	leddisplay(setledstep,1)
                        	else:
                                	setledstep = currentstep
                                	leddisplay(setledstep,1)

                        	for sample in range(0, samplecount):
                                	if step[sample] == "END":
                                        	ENDHIT="1"
				# Check the sample is actully loaded.
					if step[sample] not in sounddict and step[sample] not in special_sequence_options:
						createsounddict(sequencer_list)
		 				starttime = time.time()
                                	if "MUTE" not in step and step[sample] not in special_sequence_options:
                                        	cx = pygame.mixer.find_channel()
                                        	cx.play(sounddict[step[sample]])
				endtime = time.time()
				timedelta = endtime - starttime
				timedelta += enddelta
				sleeptime = tempocalc(tempo,timedelta)
                        	time.sleep(sleeptime)
				# Turn Lights off here!
				# The Step LEDs	
				starttime = time.time()
				leddisplay(setledstep,0)
				endtime = time.time()
				enddelta = endtime - starttime
				if sequencer_status == 0:
					break

	time.sleep(.500)
 return

sequencer = threading.Thread(target=sequencer, args=[])
sequencer.start()

def tempocalc(tempo,timedelta):
 # 60000(ms)/120(tempo)/1(note)
 #1=4
 #2=8
 #4=16	
 sleeptime = ((60/tempo)/4) - timedelta
 return sleeptime

# Thread for on screen info display
def display():
 global exitprogram
 global tempo
 global currentsequence
 global totalsequence
 global currentstep
 global laststep
 global sequencer_mode
 global sequencer_mode_current
 global sequencer_status
 global sequencer_status_display
 global pattern_sequence 
 global lightcurrentstep

 x = 1
 f = 256
 i = 1
 
 while exitprogram != 0:
 		displaysequence = currentsequence +1
#                sys.stdout.write ("\x1b7\x1b[%d;%d,%df%s\x1b8" % (50, 0, "Step"))
                sys.stdout.write ("\x1b7\x1b[%d;%df%s%s%s\x1b8" % (29, 0, "Playback: [",sequencer_status_display[sequencer_status],"]"))
                sys.stdout.write ("\x1b7\x1b[%d;%df%s%s%s\x1b8" % (30, 0, "Playback Type: [",sequencer_mode[sequencer_mode_current],"]"))
                sys.stdout.write ("\x1b7\x1b[%d;%df%s%s%s%s%s\x1b8" % (31, 0, "Steps: [",currentstep,"/",laststep,"]"))
                sys.stdout.write ("\x1b7\x1b[%d;%df%s%s%s%s%s\x1b8" % (31, 20, "Sequence: [",displaysequence,"/",totalsequence,"]"))
                sys.stdout.write ("\x1b7\x1b[%d;%df%s%s%s%s%s\x1b8" % (31, 40, "Channels: [",x,"/",i,"]"))
                sys.stdout.write ("\x1b7\x1b[%d;%df%s%s%s%s%s\x1b8" % (31, 60, "Samples: [",i,"/",i,"]"))
                sys.stdout.write ("\x1b7\x1b[%d;%df%s%s%s\x1b8" % (31, 80, "Tempo: [",tempo,"]"))
                sys.stdout.write ("\x1b7\x1b[%d;%df%s%s%s\x1b8" % (31, 100, "Pattern: [",pattern_sequence,"]"))
                sys.stdout.flush()

 time.sleep(0.3)
 

threading.Thread(target = display).start()

def buttons():
# Globals
 global exitprogram
 while exitprogram != 0:
	if trellis.readSwitches():
       		# go through every button
		for i in range(numKeys):
                # if it was pressed, turn it on
                	if trellis.justPressed(i):
                        	#print 'v{0}'.format(i)
                                trellis.setLED(i)
				buttonQueue.put(i)
                        # if it was released, turn it off
			if trellis.justReleased(i):
                         	#print '^{0}'.format(i)
                                trellis.clrLED(i)
                # tell the trellis to set the LEDs we requested
		trellis.writeDisplay()
 	time.sleep(0.03)
 #Clear all leds
 for i in range(numKeys):
	trellis.clrLED(i)
        trellis.writeDisplay()


 return


buttons = threading.Thread(target=buttons, args=[])
buttons.start()

